package _ejb.test;

import com.caucho.ejb.*;
import com.caucho.vfs.*;
import javax.ejb.*;

public class CertificateRecordBean__EJB extends QEntityContext {
  private static WriteStream dbg = LogStream.open("/caucho.com/ejb/bean");

  Bean _ejb_top_bean;
  ServerContainer container;
  EntityServer server;

  protected void init(EntityServer server)
  {
    this.server = server;
    this.container = server.getContainer();
  }

  public AbstractServer getServer()
  {
    return server;
  }

  public EntityServer getEntityServer()
  {
    return server;
  }

  Bean _caucho_begin(TransactionContext trans, boolean isHome, boolean doLoad)
  {
    if (trans == null) throw new IllegalStateException();

    Bean ptr = null;
    synchronized (this) {
      for (ptr = _ejb_top_bean; ptr != null; ptr = ptr._ejb_next)
        if (ptr._ejb_trans == trans) {
          if (isHome || ptr._ejb_state > QEntity._CAUCHO_IS_ACTIVE) {
            return ptr;
          }
          break;
        }

      if (ptr == null) {
        if (_ejb_top_bean != null && _ejb_top_bean._ejb_trans == null) {
          ptr = _ejb_top_bean;
        }
        else {
          ptr = new Bean(this);
          ptr._ejb_next = _ejb_top_bean;
          _ejb_top_bean = ptr;
          if (! isHome)
            try { ptr.ejbActivate(); } catch (Exception e) { throw com.caucho.ejb.EJBExceptionWrapper.createRuntime(e); }
        }

        ptr._ejb_trans = trans;
        trans.addObject(ptr);
      }
    }

    if (ptr._ejb_state != QEntity._CAUCHO_IS_LOADED) {
    }
    else if (! trans.isReadOnly() || doLoad && getEntityServer().doLoad(ptr._ejb_load_time)) {
      ptr._caucho_update();
    }

    return ptr;
  }

  Bean _caucho_begin_single(boolean doLoad)
  {
    Bean ptr = null;
    synchronized (this) {
      if (_ejb_top_bean != null && _ejb_top_bean._ejb_trans == null) {
        ptr = _ejb_top_bean;
      }
      else {
        ptr = new Bean(this);
        ptr._ejb_next = _ejb_top_bean;
        _ejb_top_bean = ptr;
        try { ptr.ejbActivate(); } catch (Exception e) { throw com.caucho.ejb.EJBExceptionWrapper.createRuntime(e); }
      }

      ptr._ejb_trans = com.caucho.ejb.TransactionContext.NULL_TRANSACTION;
    }

    if (! doLoad || ptr._ejb_state != QEntity._CAUCHO_IS_LOADED) {
    }
    else if (getEntityServer().doLoad(ptr._ejb_load_time)) {
      ptr._ejb_state = QEntity._CAUCHO_IS_ACTIVE;
    }

    return ptr;
  }

  public void _caucho_load()
    throws FinderException
  {
    TransactionContext trans = container.beginSupports();
    try {
      Bean bean = _caucho_begin(trans, false, true);
      if (bean._ejb_state == QEntity._CAUCHO_IS_ACTIVE) {
        bean._caucho_find();
      }
    } catch (RuntimeException e) {
      trans.setRollbackOnly(e);
      throw FinderExceptionWrapper.create(e);
    } finally {
      trans.commit();
    }
  }

  public void update()
  {
    TransactionContext trans = container.beginRequired();
    try {
      Bean bean = _caucho_begin(trans, false, false);
      bean._caucho_update();
    } finally {
      trans.commit();
    }
  }

  public void _caucho_remove_callback(Class cl, Object key)
    throws javax.ejb.RemoveException
  {
    TransactionContext trans = container.beginRequired();
    try {
      Bean bean = _caucho_begin(trans, true, false);
      bean._caucho_remove_callback(cl, key);
    } finally {
      trans.commit();
    }
  }

  public void destroy()
    throws Exception
  {
    synchronized (this) {
      Bean ptr = _ejb_top_bean;
      _ejb_top_bean = null;

      super.destroy();

      for (; ptr != null; ptr = ptr._ejb_next) {
        try {
          if (ptr._ejb_state >= QEntity._CAUCHO_IS_ACTIVE)
            ptr.ejbPassivate();
          if (ptr._ejb_state > QEntity._CAUCHO_IS_DEAD)
            ptr.unsetEntityContext();
          ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        } catch (Exception e) {
          dbg.log(e);
        }
      }

      server = null;
      container = null;
      if (viewLocal != null)
        viewLocal.destroy();
    }
  }

  public static class Bean extends _ejb.test.CertificateRecordBean__QPersist
    implements QEntity
  {
    Bean _ejb_next;

    Bean(CertificateRecordBean__EJB context)
    {
      try {
        _ejb_context = context;
        _ejb_state = QEntity._CAUCHO_IS_HOME;
        setEntityContext(context);
        _caucho_persist_init(context.server);
      } catch (Exception e) {
        dbg.log(e);
        throw com.caucho.ejb.EJBExceptionWrapper.create(e);
      }
    }

    public Object getPrimaryKey()
    {
      return _ejb_context.getPrimaryKey();
    }

    public void ejbActivate()
    {
      _ejb_state = _CAUCHO_IS_ACTIVE;
      _caucho_setPrimaryKey(_ejb_context.getPrimaryKey());
      try {super.ejbActivate(); } catch (Exception e) { throw com.caucho.ejb.EJBExceptionWrapper.createRuntime(e); }
    }

    public void _caucho_sync()
    {
      if (this._ejb_state >= _CAUCHO_IS_ACTIVE) {
        ejbStore();
      }
    }

    public void _caucho_beforeCompletion(boolean isCommit)
    {
      if (_ejb_state >= _CAUCHO_IS_LOADED && isCommit) {
        ejbStore();
      }
    }

    public void _caucho_afterCompletion(boolean isCommit)
    {
      CertificateRecordBean__EJB cxt = (CertificateRecordBean__EJB) _ejb_context;

      boolean isDead = false;
      if (! isCommit && _ejb_flags != 0) {
        _ejb_state = QEntity._CAUCHO_IS_DEAD;
        cxt.getEntityServer().removeCache(cxt.getPrimaryKey());
      }

      synchronized (cxt) {
        _ejb_flags = 0;

        if (cxt._ejb_top_bean == null) {
          isDead = true;
        }
        else if (cxt._ejb_top_bean != this) {
          isDead = true;
          Bean prev = cxt._ejb_top_bean;
          Bean ptr = prev._ejb_next;
          for (; ptr != this && ptr != null; ptr = ptr._ejb_next)
            prev = ptr;
          if (ptr != null)
            prev._ejb_next = _ejb_next;
        }
        else if (_ejb_next != null || _ejb_state < QEntity._CAUCHO_IS_HOME) {
          isDead = true;
          cxt._ejb_top_bean = _ejb_next;
        }
        else if (! isCommit && _ejb_state >= QEntity._CAUCHO_IS_LOADED)
          _ejb_state = QEntity._CAUCHO_IS_ACTIVE;
        _ejb_trans = null;
      }

      if (isDead) {
        try {
          if (isCommit && _ejb_state >= QEntity._CAUCHO_IS_ACTIVE)
              ejbPassivate();
          if (isCommit && _ejb_state > QEntity._CAUCHO_IS_DEAD)
            unsetEntityContext();
          _ejb_state = QEntity._CAUCHO_IS_DEAD;
        } catch (Exception e) {
          _ejb_state = QEntity._CAUCHO_IS_DEAD;
          throw com.caucho.ejb.EJBExceptionWrapper.createRuntime(e);
        }
      }
    }

    public void ejbStore()
    {
      super.ejbStore();
    }
  }

  protected EJBLocalHome createLocalHome()
  {
    return new LocalHome(this);
  }

  public class LocalHome extends EntityLocalHome implements test.CertificateRecordHome {
    private CertificateRecordBean__EJB context;
    private EntityServer server;
    private ServerContainer container;

    public LocalHome(CertificateRecordBean__EJB context)
    {
      this.context = context;
      this.server = context.getEntityServer();
      this.container = server.getContainer();
    }

    private CertificateRecordBean__EJB getContext()
    {
      if (context == null) {
        try {
          context = (CertificateRecordBean__EJB) server.getContext(primaryKey);
        } catch (Throwable e) {
          throw EJBExceptionWrapper.createRuntime(e);
        }
      }
      return context;
    }

    protected QEntityContext getEntityContext()
    {
      return getContext();
    }

    public EntityServer getServer()
    {
      return server;
    }

    public test.CertificateRecord create(int a0, int a1, java.lang.String a2)
      throws javax.ejb.CreateException
    {
      _ejb.test.CertificateRecordBean__EJB cxt;
      cxt = new _ejb.test.CertificateRecordBean__EJB();
      cxt.init(server);
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = cxt._caucho_begin(trans, true, false);
        ptr._ejb_flags = 1;

        int key = ptr.ejbCreate(a0, a1, a2);
        Object okey = new Integer(key);
        cxt.postCreate(okey);
        ptr._ejb_state = QEntity._CAUCHO_IS_LOADED;
        ptr._ejb_load_time = com.caucho.util.Alarm.getCurrentTime();
        ptr.ejbPostCreate(a0, a1, a2);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }

      return (test.CertificateRecord) cxt.getEJBLocalObject();
    }

    public test.CertificateRecord findByPrimaryKey(int a0)
      throws javax.ejb.FinderException
    {
      TransactionContext trans = container.beginSupports();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, true, false);
        trans.sync();
        int rawKey = ptr.ejbFindByPrimaryKey(a0);
        Object key = new Integer(rawKey);
        return (test.CertificateRecord) server.getContext(key, true).getEJBLocalObject();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }
  }

  private Local viewLocal;

  public EJBLocalObject getEJBLocalObject()
  {
    if (viewLocal == null)
      viewLocal = new Local(this);

    return viewLocal;
  }

  public static class Local extends EntityLocal implements test.CertificateRecord {
    private CertificateRecordBean__EJB context;
    private EntityServer server;
    private ServerContainer container;
    private Object primaryKey;

    public Local(CertificateRecordBean__EJB context)
    {
      this.context = context;
      this.server = context.getEntityServer();
      this.container = server.getContainer();
      this.primaryKey = context.getPrimaryKey();
    }

    private CertificateRecordBean__EJB getContext()
    {
      if (context == null) {
        try {
          context = (CertificateRecordBean__EJB) server.getContext(primaryKey);
        } catch (Throwable e) {
          throw EJBExceptionWrapper.createRuntime(e);
        }
      }
      return context;
    }

    protected QEntityContext getEntityContext()
    {
      return getContext();
    }

    public EntityServer getServer()
    {
      return server;
    }

    public QEntity _caucho_getBean()
    {
      TransactionContext trans = container.getTransactionContext();
      return getContext()._caucho_begin(trans, false, true);
    }

    public QEntity _caucho_getBean(boolean doLoad)
    {
      TransactionContext trans = container.getTransactionContext();
      return getContext()._caucho_begin(trans, false, doLoad);
    }

    public Handle getHandle()
    {
      return getContext().getHandle();
    }

    public int getAcc_id()
    {
      TransactionContext trans = container.beginSingleRead();
      Bean ptr = null;
      try {
        if (trans == null)
          ptr = getContext()._caucho_begin_single(true);
        else
          ptr = getContext()._caucho_begin(trans, false, true);
        return ptr.getAcc_id();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        if (trans == null)
          throw e;
        else
          throw trans.setRollbackOnly(e);
      } finally {
        if (trans == null) {
          if (ptr != null)
            ptr._caucho_afterCompletion(ptr._ejb_state != QEntity._CAUCHO_IS_DEAD);
        } else 
          trans.commit();
      }
    }

    public java.lang.String getCertificate()
    {
      TransactionContext trans = container.beginSingleRead();
      Bean ptr = null;
      try {
        if (trans == null)
          ptr = getContext()._caucho_begin_single(true);
        else
          ptr = getContext()._caucho_begin(trans, false, true);
        return ptr.getCertificate();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        if (trans == null)
          throw e;
        else
          throw trans.setRollbackOnly(e);
      } finally {
        if (trans == null) {
          if (ptr != null)
            ptr._caucho_afterCompletion(ptr._ejb_state != QEntity._CAUCHO_IS_DEAD);
        } else 
          trans.commit();
      }
    }

    public java.lang.String getAct_TS()
    {
      TransactionContext trans = container.beginSingleRead();
      Bean ptr = null;
      try {
        if (trans == null)
          ptr = getContext()._caucho_begin_single(true);
        else
          ptr = getContext()._caucho_begin(trans, false, true);
        return ptr.getAct_TS();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        if (trans == null)
          throw e;
        else
          throw trans.setRollbackOnly(e);
      } finally {
        if (trans == null) {
          if (ptr != null)
            ptr._caucho_afterCompletion(ptr._ejb_state != QEntity._CAUCHO_IS_DEAD);
        } else 
          trans.commit();
      }
    }

    public java.lang.String getTS()
    {
      TransactionContext trans = container.beginSingleRead();
      Bean ptr = null;
      try {
        if (trans == null)
          ptr = getContext()._caucho_begin_single(true);
        else
          ptr = getContext()._caucho_begin(trans, false, true);
        return ptr.getTS();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        if (trans == null)
          throw e;
        else
          throw trans.setRollbackOnly(e);
      } finally {
        if (trans == null) {
          if (ptr != null)
            ptr._caucho_afterCompletion(ptr._ejb_state != QEntity._CAUCHO_IS_DEAD);
        } else 
          trans.commit();
      }
    }

    public void setAct_TS(java.lang.String a0)
    {
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false, true);
        ptr.setAct_TS(a0);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }

    public void setTS(java.lang.String a0)
    {
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false, true);
        ptr.setTS(a0);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }

    public int getCert_id()
    {
      TransactionContext trans = container.beginSingleRead();
      Bean ptr = null;
      try {
        if (trans == null)
          ptr = getContext()._caucho_begin_single(false);
        else
          ptr = getContext()._caucho_begin(trans, false, false);
        return ptr.getCert_id();
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        if (trans == null)
          throw e;
        else
          throw trans.setRollbackOnly(e);
      } finally {
        if (trans == null) {
          if (ptr != null)
            ptr._caucho_afterCompletion(ptr._ejb_state != QEntity._CAUCHO_IS_DEAD);
        } else 
          trans.commit();
      }
    }

    public void setAcc_id(int a0)
    {
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false, true);
        ptr.setAcc_id(a0);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }

    public void setCert_id(int a0)
    {
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false, true);
        ptr.setCert_id(a0);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }

    public void setCertificate(java.lang.String a0)
    {
      TransactionContext trans = container.beginRequired();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false, true);
        ptr.setCertificate(a0);
      } catch (RuntimeException e) {
        if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
      }
    }

    public void remove()
      throws javax.ejb.RemoveException
    {
      try {
        TransactionContext trans = container.beginRequired();
        Bean ptr = null;
        try {
          ptr = getContext()._caucho_begin(trans, false, true);
          if (ptr._ejb_state < QEntity._CAUCHO_IS_ACTIVE)
            throw new java.lang.IllegalStateException("can't remove already dead obect.");
          trans.sync();
          ptr.ejbRemove();
          ptr._ejb_state = QEntity._CAUCHO_IS_REMOVED;
          getServer().removeCache(primaryKey);
          ptr.unsetEntityContext();
        } catch (RuntimeException e) {
          if (ptr != null) ptr._ejb_state = QEntity._CAUCHO_IS_DEAD;
          throw trans.setRollbackOnly(e);
        } finally {
          trans.commit();
        }
      } catch (javax.ejb.RemoveException e) {
        throw e;
      } catch (Exception e) {
        throw com.caucho.ejb.EJBExceptionWrapper.createRuntime(e);
      }
    }

    void destroy()
    {
      context = null;
    }

    public String toString()
    {
      return "[test.CertificateRecordBean$Local " + primaryKey + "]";
    }
  }

  private static com.caucho.vfs.Depend []_caucho_depend;

  public static void _caucho_init(com.caucho.vfs.Path path)
  {
    _caucho_depend = new com.caucho.vfs.Depend[5];
    _caucho_depend[0] = new com.caucho.vfs.Depend(path.lookup("./AccountBean.ejb"), 1034867685354L, 3181);
    _caucho_depend[0].setRequireSource(true);
    _caucho_depend[1] = new com.caucho.vfs.Depend(path.lookup("./test/CertificateRecordBean.class"), 1034868114809L, 835);
    _caucho_depend[1].setRequireSource(true);
    _caucho_depend[2] = new com.caucho.vfs.Depend(path.lookup("./test/CertificateRecordHome.class"), 1034868056403L, 401);
    _caucho_depend[2].setRequireSource(true);
    _caucho_depend[3] = new com.caucho.vfs.Depend(path.lookup("./test/CertificateRecord.class"), 1034868059341L, 441);
    _caucho_depend[3].setRequireSource(true);
    _caucho_depend[4] = new com.caucho.vfs.Depend(path.lookup("./_ejb/test/CertificateRecordBean__QPersist.class"), 1034868117699L, 9913);
    _caucho_depend[4].setRequireSource(true);
  }

  public static boolean _caucho_is_modified()
  {
    if (com.caucho.ejb.Version.getVersionId() != 2003742913)
      return true;
    for (int i = _caucho_depend.length - 1; i >= 0; i--) {
      if (_caucho_depend[i].isModified())
        return true;
    }

    return false;
  }
}
