package _ejb.test;

import com.caucho.ejb.*;
import com.caucho.vfs.*;
import javax.ejb.*;

public class CertificationBean__EJB extends QSessionContext {
  private static WriteStream dbg = LogStream.open("/caucho.com/ejb/bean");

  Bean _ejb_top_bean;
  ServerContainer container;
  SessionServer server;

  protected void init(SessionServer server)
  {
    this.server = server;
    this.container = server.getContainer();
  }

  public AbstractServer getServer()
  {
    return server;
  }

  public SessionServer getSessionServer()
  {
    return server;
  }

  Bean _caucho_begin(TransactionContext trans, boolean isHome)
    throws javax.ejb.EJBException
  {
    Bean ptr;
    synchronized (this) {
      for (ptr = _ejb_top_bean; ptr != null; ptr = ptr._ejb_next) {
        if (! ptr._ejb_isActive) {
          ptr._ejb_isActive = true;
          return ptr;
        }
      }

      ptr = new Bean(this);
      ptr._ejb_next = _ejb_top_bean;
      _ejb_top_bean = ptr;
      ptr._ejb_isActive = true;
    }

    return ptr;
  }

  public void destroy()
  {
    Bean ptr;
    synchronized (this) {
      for (ptr = _ejb_top_bean; ptr != null; ptr = ptr._ejb_next) {
        try {
          ptr.ejbRemove();
        } catch (Exception e) {
          dbg.log(e);
        }
      }
    }
    _ejb_top_bean = null;
  }

  public static class Bean extends test.CertificationBean
  {
    Bean _ejb_next;
    CertificationBean__EJB _ejb_context;
    boolean _ejb_isActive;

    Bean(CertificationBean__EJB context)
    {
      try {
        _ejb_context = context;
        setSessionContext(context);
        ejbCreate();
      } catch (Exception e) {
        dbg.log(e);
        throw com.caucho.ejb.EJBExceptionWrapper.create(e);
      }
    }
  }

  public EJBHome createRemoteHomeView()
  {
    return new Home(this);
  }

  public class Home extends SessionHome implements test.CertificationHome {
    private CertificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Home(CertificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private CertificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public test.Certification create()
      throws java.rmi.RemoteException, javax.ejb.CreateException
    {
      _ejb.test.CertificationBean__EJB cxt = getContext();

      return (test.Certification) cxt.getEJBObject();
    }
  }

  private Remote viewRemote;

  public EJBObject getRemoteView()
  {
    if (viewRemote == null)
      viewRemote = new Remote(this);

    return viewRemote;
  }

  public static class Remote extends StatelessObject implements test.Certification {
    private CertificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Remote(CertificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private CertificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public Handle getHandle()
    {
      return getContext().getHandle();
    }

    public java.lang.String getCertificate(java.lang.String a0, java.lang.String a1)
    {
      java.lang.String _ret;
      TransactionContext trans = container.suspend();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false);
        _ret = ptr.getCertificate(a0, a1);
      } catch (RuntimeException e) {
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
        if (ptr != null) ptr._ejb_isActive = false;
      }
      return _ret;
    }
  }

  protected EJBLocalHome createLocalHome()
  {
    return new LocalHome(this);
  }

  public class LocalHome extends SessionHome implements test.CertificationLocalHome {
    private CertificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    LocalHome(CertificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private CertificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public test.CertificationLocal create()
      throws javax.ejb.CreateException
    {
      _ejb.test.CertificationBean__EJB cxt = getContext();

      return (test.CertificationLocal) cxt.getEJBLocalObject();
    }
  }

  private Local viewLocal;

  public EJBLocalObject getEJBLocalObject()
  {
    if (viewLocal == null)
      viewLocal = new Local(this);

    return viewLocal;
  }

  public static class Local extends StatelessObject implements test.CertificationLocal {
    private CertificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Local(CertificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private CertificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public Handle getHandle()
    {
      return getContext().getHandle();
    }

    public java.lang.String getCertificate(java.lang.String a0, java.lang.String a1)
    {
      java.lang.String _ret;
      TransactionContext trans = container.suspend();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false);
        _ret = ptr.getCertificate(a0, a1);
      } catch (RuntimeException e) {
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
        if (ptr != null) ptr._ejb_isActive = false;
      }
      return _ret;
    }
  }

  private static com.caucho.vfs.Depend []_caucho_depend;

  public static void _caucho_init(com.caucho.vfs.Path path)
  {
    _caucho_depend = new com.caucho.vfs.Depend[7];
    _caucho_depend[0] = new com.caucho.vfs.Depend(path.lookup("./AccountBean.ejb"), 1034867685354L, 3181);
    _caucho_depend[0].setRequireSource(true);
    _caucho_depend[1] = new com.caucho.vfs.Depend(path.lookup("./test/CertificationBean.class"), 1034867407850L, 1239);
    _caucho_depend[1].setRequireSource(true);
    _caucho_depend[2] = new com.caucho.vfs.Depend(path.lookup("./test/CertificationHome.class"), 1034801702056L, 298);
    _caucho_depend[2].setRequireSource(true);
    _caucho_depend[3] = new com.caucho.vfs.Depend(path.lookup("./test/Certification.class"), 1034801764697L, 301);
    _caucho_depend[3].setRequireSource(true);
    _caucho_depend[4] = new com.caucho.vfs.Depend(path.lookup("./test/CertificationLocalHome.class"), 1034801725994L, 286);
    _caucho_depend[4].setRequireSource(true);
    _caucho_depend[5] = new com.caucho.vfs.Depend(path.lookup("./test/CertificationLocal.class"), 1034801765432L, 263);
    _caucho_depend[5].setRequireSource(true);
    _caucho_depend[6] = new com.caucho.vfs.Depend(path.lookup("./test/CertificationBean.class"), 1034867407850L, 1239);
    _caucho_depend[6].setRequireSource(true);
  }

  public static boolean _caucho_is_modified()
  {
    if (com.caucho.ejb.Version.getVersionId() != 2003742913)
      return true;
    for (int i = _caucho_depend.length - 1; i >= 0; i--) {
      if (_caucho_depend[i].isModified())
        return true;
    }

    return false;
  }
}
