package test;

import javax.ejb.*;
import java.rmi.*;
import com.caucho.ejb.*;
import javax.naming.*;
import javax.servlet.*;

public class AccountBean extends AbstractSessionBean {

  private AccountRecordHome home;

  public void ejbCreate() {
    try {
      Context cmp = (Context) new InitialContext().lookup("java:comp/env/cmp");

      home = (AccountRecordHome) cmp.lookup("AccountRecordBean");
    } catch (NamingException e) {
      e.printStackTrace();
    }
  }

  public boolean createAccount(String username, String password) {
    try {
      home.create(username, password);
      return true;
    } catch ( CreateException e) {
      return false;
    }
  }
}