package test;

import javax.ejb.*;
import java.rmi.*;
import com.caucho.ejb.*;
import javax.naming.*;
import javax.servlet.*;

public class CertificationBean extends AbstractSessionBean {

  private CertificateRecordHome certHome;
  private AccountRecordHome accountHome;

  public void ejbCreate() {
    try {
      Context cmp = (Context) new InitialContext().lookup("java:comp/env/cmp");

      certHome = (CertificateRecordHome) cmp.lookup("CertificateRecordBean");
      accountHome = (AccountRecordHome) cmp.lookup("AccountRecordBean");
    } catch (NamingException e) {
      e.printStackTrace();
    }

  }

  public String getCertificate(String username, String password) {
    try {
      AccountRecord account = accountHome.findByUsernamePassword(username, password);
      return account.getAcc_id() + "";
    } catch ( CreateException e) {
      return "not found";
    }
//    return "certificate";
  }

}